leetcode面试题17.最大子矩阵

sooooooo long没刷题了,汗颜

题目链接:leetcode面试题17

1.题目

给定一个正整数、负整数和 0 组成的 N × M 矩阵,编写代码找出元素总和最大的子矩阵。

返回一个数组 r1, c1, r2, c2,其中 r1, c1 分别代表子矩阵左上角的行号和列号,r2, c2 分别代表右下角的行号和列号。若有多个满足条件的子矩阵,返回任意一个均可。

n,m<-200

2.分析

1)最初想到的版本:

首先fij0表示第i行前j个格子的前缀和,fij1表示第j列前i个格子的前缀和,那么以len1,len2,col1,col2为左上角和右下角的矩阵的子矩阵和为:flen2col22-flen2col1-12-flen1-1col22+flen1-1col1-12;但这样我们就需要枚举len1,len2,col1,col2,复杂度为NN MM
2)在此基础上优化,我们可以发现,在确定了len1,len2,col1时,我们只需要使得flen2col22-flen1-1col22最大即可,那么我们把col1从n-1->0枚举的过程中可以逐步去比较当前最大的flen2col22-flen1-1col22和当col2=col1时的flen2col22-flen1-1col22谁更大,维护一下最大值即可,那么复杂度降低为M
M*N,可以AC

3.代码

cpp 复制代码
class Solution {
public:
    int f[210][210][5];
    static bool mycmp(vector<int> x,vector<int> y){
        return x[0]>y[0];
    }
    int get_sum(int len1,int len2,int col1,int col2){
        return f[len2][col2][2]-f[len1-1][col2][2];
    }
    vector<int> getMaxMatrix(vector<vector<int>>& matrix) {
        memset(f,0,sizeof(f));
        int m=matrix.size(),n=matrix[0].size();
        for(int i=0;i<m;i++)
            for(int j=0;j<n;j++){
                int len=i+1,col=j+1,c=matrix[i][j];
                f[len][col][0]=f[len-1][col][0]+c;
                f[len][col][1]=f[len][col-1][1]+c;
                f[len][col][2]=f[len-1][col-1][2]+f[len][col-1][1]+f[len-1][col][0]+c;
            }
        int ans=matrix[0][0],r1=0,r2=0,c1=0,c2=0;
        for(int i=0;i<m;i++)
            for(int k=i;k<m;k++){
                int len1=i+1,len2=k+1,col2=n;
                int col_sum=f[len2][col2][2]-f[len1-1][col2][2];
                for(int j=n-1;j>=0;j--)
                {
                    int col1=j+1;
                    if(get_sum(len1,len2,col1,j+1)>col_sum){
                        col_sum=get_sum(len1,len2,col1,j+1);
                        col2=j+1;
                    }
                    int ans_test=f[len2][col2][2]-f[len2][col1-1][2]-f[len1-1][col2][2]+f[len1-1][col1-1][2];
                    if(ans_test>ans){
                        ans=ans_test;
                        r1=i,c1=j,r2=k,c2=col2-1;
                    }
                }
            }
        vector<int> ans_vec;
        ans_vec.push_back(r1);
        ans_vec.push_back(c1);
        ans_vec.push_back(r2);
        ans_vec.push_back(c2);
        return ans_vec;
    }

};
相关推荐
hanlin036 小时前
刷题笔记:力扣第32题-最长有效括号
笔记·算法·leetcode
All for pursuit.6 小时前
【动态规划-21】312.戳气球
数据结构·c++·算法·leetcode·动态规划
碧海银沙音频科技研究院9 小时前
基于炬芯ATS3089X自研AEC声学回声消除算法
算法
通问AI9 小时前
在两台 Mac Studio 上跑 800B 模型:MLX + RDMA over Thunderbolt 实测与四道门选型法
算法
ZywOo6239 小时前
《算法竞赛进阶指南》0x03 前缀和与差分
算法
Scintilla_y9 小时前
DAY2 滑动窗口
算法·leetcode·散列表
lvwangshu9 小时前
笛卡尔树
算法·图论
026d239 小时前
状态信号只知“其然”不知“其所以然”:变工况机械故障诊断的物理盲区
算法
姜鱼问生10 小时前
备份和服务器在同一台机器上,等于没备份
算法·架构
姜鱼问生10 小时前
别再 chmod 777 了,用 ACL 给它开一扇窗
后端·算法·架构